<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var LIB_FILES_PATH = '/home/SCANB/LibPlateQC';
var firstBrowse = true;
var subtypeInfo = [];

var debug = false;
var currentStep = 1;

var dateIsValid = [];
var wellTableIsValid = false;
var qubitCsvIsValid = false;
var libCommentsIsValid = false;

function init()
{
	var frm = document.forms['reggie'];
	var bioplates = getLibraryBioPlates();
	
	// Load existing Library plates not yet registered
	var plates = frm.bioplate;
	if (bioplates != null && bioplates.length > 0)
	{
		for (var i=0; i < bioplates.length; i++)
		{
			var bioplate = bioplates[i];
			var warning = bioplate.numFiles == 0 ? ' ( ! )' : '';
			var option = new Option(bioplate.name + warning, bioplate.id);
			option.bioplate = bioplate;
			plates.options[plates.length] = option;
		}
		bioplateIsValid = true;
		setInputStatus('bioplate', '', 'valid');
		bioPlateOnChange();
		outcomeOnChange();
	}
	else
	{
		var msg = 'No Library bioplates available for processing.';
		setFatalError(msg);
		return;
	}

	// All is ok
	frm.bioplate.focus();
}


function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	setCurrentStep(currentStep);
}



function getLibraryBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Library bioplates...');
		var url = '../LibPrep.servlet?ID=<%=ID%>&cmd=GetLibraryPlatesForLibPrep';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.bioplates;
}

function gotoStep2()
{
	var frm = document.forms['reggie'];	
	frm.bioplate.disabled = true;
	frm.outcome[0].disabled = true;
	frm.outcome[1].disabled = true;
	
	currentStep = 2;
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.hide('gonext');
	Main.show('gocancel');
	Main.show('goregister');
	
	var libInfo = getStoredInfo(frm.bioplate.value);
	if (libInfo)
	{
		if (debug) Main.debug(JSON.stringify(libInfo));
		var failed = document.getElementById('outcomeFailed').checked;
		
		if (libInfo.amplificationDate) 
		{
			frm.amplificationDate.value = libInfo.amplificationDate;
			frm.amplificationOperator.value = libInfo.amplificationOperator;
			dateOnChange('amplificationDate');
		}
		if (libInfo.cleanupDate) 
		{
			frm.cleanupDate.value = libInfo.cleanupDate;
			frm.cleanupOperator.value = libInfo.cleanupOperator;
			dateOnChange('cleanupDate');
		}
		if (!failed)
		{
			if (libInfo.wellTable.id && libInfo.wellTable.path)
			{
				lastPrefix = 'welltable';
				setFileCallback(libInfo.wellTable.id, libInfo.wellTable.path);
			}
			if (libInfo.caliperGxd.id && libInfo.caliperGxd.path)
			{
				lastPrefix = 'calipergxd';
				setFileCallback(libInfo.caliperGxd.id, libInfo.caliperGxd.path);
			}
			if (libInfo.caliperPdf.id && libInfo.caliperPdf.path)
			{
				lastPrefix = 'caliperpdf';
				setFileCallback(libInfo.caliperPdf.id, libInfo.caliperPdf.path);
			}
			if (libInfo.qubitCsv.id && libInfo.qubitCsv.path)
			{
				lastPrefix = 'qubitcsv';
				setFileCallback(libInfo.qubitCsv.id, libInfo.qubitCsv.path);
			}
		}
		if (libInfo.libComments) 
		{
			frm.libComments.value = libInfo.libComments;
		}
	}
	
	Main.show('step.2.section');
	frm.amplificationDate.focus();

	// Load Library protocols
	var libProtocols = getProtocols('LIBRARY_PROTOCOL');
	for (var i = 0; i < libProtocols.length; i++)
	{
		var protocol = libProtocols[i];
		frm.libProtocol[frm.libProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('libProtocol', '', 'valid');
	}
	if (frm.libProtocol.length == 0)
	{
		frm.libProtocol[0] = new Option('- none -', '');
	}
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function bioPlateOnChange()
{
	var frm = document.forms['reggie'];
	var selectedPlate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;
	if (selectedPlate.numFiles == 0)
	{
		setInputStatus('bioplate', 'No quality control PDF has been registered for this plate', 'warning');
	}
	else
	{
		setInputStatus('bioplate', '', 'valid');
	}
}

function outcomeOnChange()
{
	var frm = document.forms['reggie'];
	var failed = document.getElementById('outcomeFailed').checked

	if (failed)
	{
		Main.addClass(frm.libComments, 'required');
		Main.hide('filesSection');
	}
	else
	{
		Main.removeClass(frm.libComments, 'required');
		Main.show('filesSection');
	}
}

var lastPrefix;
function browseOnClick(prefix, extension, subtype)
{
	var frm = document.forms['reggie'];
	if (frm[prefix+'.path'].disabled) return;
	
	if (firstBrowse)
	{
		firstBrowse = false;
		setCurrentDirectory('<%=ID%>', LIB_FILES_PATH, debug, '../');
	}
	if (subtypeInfo[subtype] == undefined)
	{
		subtypeInfo[subtype] = getSubtypeInfo('<%=ID%>', subtype, debug, '../');
	}
	
	var url = getRoot() + 'filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
	url += '&resetTemporary=1&tmpfilter:STRING:name='+escape('%.' + extension);
	if (subtypeInfo[subtype])
	{
		url += '&tmpfilter:INT:itemSubtype='+subtypeInfo[subtype].id;
	}
	lastPrefix = prefix;
	Main.openPopup(url, 'SelectFile', 1000, 700);
}

function setFileCallback(id, path)
{
	var frm = document.forms['reggie'];
	frm[lastPrefix+'.id'].value = id;
	frm[lastPrefix+'.path'].value = path;
	
	if (lastPrefix == 'welltable')
	{
		saveToLocalStorage(frm.bioplate.value);
		setTimeout(preValidateCsvFile, 100);
	}
	else if (lastPrefix == 'qubitcsv')
	{
		qubitCsvFileOnChange();
	}
	else
	{
		setInputStatus(lastPrefix, '', 'valid');
	}
}

function dateOnChange(dateField)
{
	var frm = document.forms['reggie'];

	setInputStatus(dateField, '', '');
	dateIsValid[dateField] = true;
	var date = frm[dateField].value;

	if (date == '')
	{
		setInputStatus(dateField, 'Missing date', 'warning');
		return;
	}

	// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
	date = autoFillDate(date);
	frm[dateField].value = date;
	if (!Dates.isDate(date, 'yyyyMMdd'))
	{
		setInputStatus(dateField, 'Not a valid date', 'invalid');
		dateIsValid[dateField] = false;
		return;
	}
	
	setInputStatus(dateField, '', 'valid');
}

function setDate(frmName, dateField, date)
{
	var frm = document.forms['reggie'];
	frm[dateField].value = date;
	dateOnChange(dateField);
	frm[dateField].focus();
}


function preValidateCsvFile()
{
	var frm = document.forms['reggie'];
	var csvId = frm['welltable.id'].value;
	var csvPath = frm['welltable.path'].value;
	
	wellTableIsValid = false;
	
	if (!csvId) 
	{
		setInputStatus('welltable', 'Missing', 'invalid');
		return;
	}
	
	Main.addClass(document.body, 'please-wait');
	setInputStatus('welltable', 'Checking...', 'checking');
	var qubitCsv = frm['qubitcsv.id'].value;
	var url = '../LibPrep.servlet?ID=<%=ID%>&cmd=PreValidateCaliperWellTable&csv='+csvId+'&bioplate='+frm.bioplate.value+'&qubit='+qubitCsv;
	
	var request = Ajax.getXmlHttpRequest();
	Ajax.setReadyStateHandler(request, onWellTableValidated);
	request.open("POST", url, true);	
	request.send('');
}

function onWellTableValidated(request)
{
	Main.removeClass(document.body, 'please-wait');
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	var numWarnings = 0;
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
				numWarnings++;
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	else
	{
		Main.hide('messages');	
	}
	
	if (response.status != 'ok')
	{
		setInputStatus('welltable', response.message, 'invalid');
		Main.addClass(document.getElementById('messages'), 'failure');
		return;
	}

	setInputStatus('welltable', '', numWarnings > 0 ? 'warning' : 'valid');
	Main.removeClass(document.getElementById('messages'), 'failure');
	wellTableIsValid = true;
}


function qubitCsvFileOnChange()
{
	var frm = document.forms['reggie'];
	qubitCsvIsValid = false;
	if (!frm['qubitcsv.id'].value)
	{
		// A PDF is reuired for successful registration, optional after a failure
		var msg = frm['qubitcsv.path'].value ? 'Use the Browse button to select a file' : 'Missing';
		setInputStatus('qubitcsv', msg, 'invalid');
		return;
	}
	qubitCsvIsValid = true;
	setInputStatus('qubitcsv', '', 'valid');
}

function libCommentsOnChange()
{
	var failed = document.getElementById('outcomeFailed').checked;
	if (!failed) return;

	var frm = document.forms['reggie'];
	libCommentsIsValid = false;
	setInputStatus('libComments', '', '');
	
	var comments = frm.libComments.value;
	if (comments == '')
	{
		setInputStatus('libComments', 'Missing', 'invalid');
		return;
	}

	setInputStatus('libComments', '', 'valid');
	libCommentsIsValid = true;
}


function step2IsValid()
{
	if (dateIsValid['amplificationDate'] == false) return false;
	if (dateIsValid['cleanupDate'] == false) return false;
	
	var failed = document.getElementById('outcomeFailed').checked;
	if (failed)
	{
		return libCommentsIsValid;
	}
	else
	{
		return wellTableIsValid && qubitCsvIsValid;
	}	
}

function goRegister()
{
	if (!step2IsValid()) return;
	
	Main.hide('messages');
	Main.hide('goregister');
	Main.hide('gocancel');

	var frm = document.forms['reggie'];
	var libPlateId = parseInt(frm.bioplate.value, 10);
	var submitInfo = {};
	submitInfo.bioplate = libPlateId;

	Main.addClass(document.getElementById('step.2.section'), 'disabled');
	var	url = '../LibPrep.servlet?ID=<%=ID%>&cmd=ImportLibPrepResults';
	var failed = document.getElementById('outcomeFailed').checked;
	submitInfo.failed = failed;
		
	if (!failed)
	{
		saveToLocalStorage(libPlateId);
		submitInfo.wellTableCsv = parseInt(frm['welltable.id'].value, 10);
		submitInfo.caliperGxd = parseInt(frm['calipergxd.id'].value, 10);
		submitInfo.caliperPdf = parseInt(frm['caliperpdf.id'].value, 10);
		submitInfo.qubitCsv = parseInt(frm['qubitcsv.id'].value, 10);
	}
		
	submitInfo.amplificationDate = frm.amplificationDate.value;
	submitInfo.amplificationOperator = frm.amplificationOperator.value;
	submitInfo.cleanupDate = frm.cleanupDate.value;
	submitInfo.cleanupOperator = frm.cleanupOperator.value;
	submitInfo.libProtocol = parseInt(frm.libProtocol.value, 10);
	submitInfo.libComments = frm.libComments.value;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	removeFromLocalStorage(libPlateId);
	Main.removeClass(document.getElementById('messages'), 'failure');
	Main.show('gorestart');	
}


/**
	Save as much information as possible about the library registration.
	The information is stored in the localStorage()
	under the key 'reggie.libplate.<id>.info' where
	<id> is the ID of the library plate.
*/
function saveToLocalStorage(libPlateId)
{
	if (window.localStorage)
	{
		var frm = document.forms['reggie'];
		var libInfo = new Object();
		libInfo.id = libPlateId;
		libInfo.amplificationDate = frm.amplificationDate.value;
		libInfo.amplificationOperator = frm.amplificationOperator.value;
		libInfo.cleanupDate = frm.cleanupDate.value;
		libInfo.cleanupOperator = frm.cleanupOperator.value;
		libInfo.wellTable = { id: frm['welltable.id'].value, path: frm['welltable.path'].value };
		libInfo.caliperGxd = { id: frm['calipergxd.id'].value, path: frm['calipergxd.path'].value };
		libInfo.caliperPdf = { id: frm['caliperpdf.id'].value, path: frm['caliperpdf.path'].value };
		libInfo.qubitCsv = { id: frm['qubitcsv.id'].value, path: frm['qubitcsv.path'].value };
		libInfo.libProtocol = frm.libProtocol.value;
		libInfo.libComments = frm.libComments.value;
		
		window.localStorage.setItem('reggie.libplate.' + libPlateId + '.info', JSON.stringify(libInfo));
		if (debug)
		{
			Main.debug(libPlateId + ': ' + window.localStorage.getItem('reggie.libplate.' + libPlateId + '.info'));
		}
	}
}

function removeFromLocalStorage(libPlateId)
{
	if (!window.localStorage) return;
	if (debug) Main.debug('removeFromLocalStorage:' + libPlateId);
	window.localStorage.removeItem('reggie.libplate.' + libPlateId + '.info');
}

function getStoredInfo(libPlateId)
{
	if (!window.localStorage) return null;
	try
	{
		var stored = window.localStorage.getItem('reggie.libplate.' + libPlateId + '.info');
		if (debug) Main.debug(libPlateId + ': ' + stored);
		return stored ? JSON.parse(stored) : null;
	}
	catch (e)
	{
		Main.debug('Could not load stored information for tube ' + tubeId + ': ' + e);
	}
}


</script>
<style>
body.please-wait
{
	cursor: wait !important;
}
</style>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Library registration" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
		<input type="hidden" name="pdf.id" value="">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select Library bioplate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Library bioplate</td>
				<td class="input"><select class="required" style="width:90%;" 
						name="bioplate" id="bioplate" onchange="bioPlateOnChange()"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help"><span id="bioplate.message" class="message" style="display: none;"></span>
					Select an existing Library bioplate. The list contain all Library bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top" id="outcomeSection">
				<td class="prompt">Outcome</td>
				<td class="input">
					<input type="radio" name="outcome" id="outcomeSuccess" 
						onchange="outcomeOnChange()" checked><label for="outcomeSuccess">Success</label> - continue processing<br>
					<input type="radio" name="outcome" id="outcomeFailed" 
						onchange="outcomeOnChange()"><label for="outcomeFailed">Failure</label> - no further processing
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Failure</b> option if further processing to pooled libraries is not possible.
					Existing RNA will be flagged and added to the <b>Flagged RNA</b> list.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle">Full plate registration</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Step</td>
				<td style="width: 11em;"><b>Date</b></td>
				<td><b>Operator</b></td>
				<td class="status"></td>
				<td class="help" rowspan="3">
					<span id="mrnaDate.message" class="message" style="display: none;"></span>
					Enter date and operator for each step in the library preparation.
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="subprompt">Amplification</td>
				<td>
					<input type="text" name="amplificationDate" maxlength="10" style="width: 8em;"
						onblur="dateOnChange('amplificationDate')" onkeypress="focusOnEnter(event, 'amplificationOperator')">
						<base:icon 
							onclick="Dates.selectDate('Amplification date', 'reggie', 'amplificationDate', 'setDate', 'yyyyMMdd')"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td>
					<input type="text" name="amplificationOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 95%;" maxlength="255" onkeypress="focusOnEnter(event, 'cleanupDate')">
				</td>
				<td class="status" id="amplificationDate.status"></td>
			</tr>
			<tr>
				<td class="subprompt">Cleanup</td>
				<td>
					<input type="text" name="cleanupDate" maxlength="10" style="width: 8em;"
						onblur="dateOnChange('cleanupDate')" onkeypress="focusOnEnter(event, 'cleanupOperator')">
						<base:icon 
							onclick="Dates.selectDate('Cleanup date', 'reggie', 'cleanupDate', 'setDate', 'yyyyMMdd')"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td>
					<input type="text" name="cleanupOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 95%;" maxlength="255" onkeypress="focusOnEnter(event, 'qubitcsv.path')">
				</td>
				<td class="status" id="cleanupDate.status"></td>
			</tr>
			<tbody id="filesSection">
			<tr>
				<td class="prompt">Qubit files</td>
				<td class="input" colspan="2"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Conc. CSV</td>
				<td class="input" colspan="2">
					<input type="hidden" name="qubitcsv.id" value="">
					<table>
					<tr>
					<td><input class="text required" type="text" 
						name="qubitcsv.path" value=""
						size="50" onkeypress="doOnEnter(event, function(){document.getElementById('btnQubitCsv').click()})"
						onblur="qubitCsvFileOnChange()"
						></td>
					<td style="padding-left: 4px;"><base:button 
							title="Browse&hellip;"
							onclick="browseOnClick('qubitcsv', 'csv', 'QUBIT_CSV')"
							id="btnQubitCsv"
							/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="qubitcsv.status"></td>
				<td class="help"><span id="qubitcsv.message" class="message" style="display: none;"></span>
					Select the <b>Qubit CSV</b> file that contains the table with concentration
					measurements.
				</td>
			</tr>
			<tr>
				<td class="prompt">Caliper files</td>
				<td class="input" colspan="2"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Well table CSV</td>
				<td class="input" colspan="2">
					<input type="hidden" name="welltable.id" value="">
					<table>
					<tr>
					<td><input class="text required" type="text" 
						name="welltable.path" value=""
						size="50" onkeypress="doOnEnter(event, function(){document.getElementById('btnWellTable').click()})"
						onblur="csvFileOnChange()"
						></td>
					<td style="padding-left: 4px;"><base:button 
							title="Browse&hellip;"
							onclick="browseOnClick('welltable', 'csv', 'CALIPER_WELL_TABLE')"
							id="btnWellTable"
							/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="welltable.status"></td>
				<td class="help"><span id="welltable.message" class="message" style="display: none;"></span>
					 Select the <b>Well Table CSV</b> file that contains the exported analysis 
					 result from the Caliper software. 
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">GXD raw data</td>
				<td class="input" colspan="2">
					<input type="hidden" name="calipergxd.id" value="">
					<table>
					<tr>
					<td><input class="text" type="text" 
						name="calipergxd.path" value=""
						size="50" onkeypress="doOnEnter(event, function(){document.getElementById('btnCaliperGxd').click()})"
						></td>
					<td style="padding-left: 4px;"><base:button 
							title="Browse&hellip;"
							onclick="browseOnClick('calipergxd', 'gxd', 'CALIPER_RAW_DATA')"
							id="btnCaliperGxd"
							/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="calipergxd.status"></td>
				<td class="help"><span id="calipergxd.message" class="message" style="display: none;"></span>
					Select the <b>GXD raw data file</b> from Caliper.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">PDF file</td>
				<td class="input" colspan="2">
					<input type="hidden" name="caliperpdf.id" value="">
					<table>
					<tr>
					<td><input class="text" type="text" 
						name="caliperpdf.path" value=""
						size="50" onkeypress="doOnEnter(event, function(){document.getElementById('btnCaliperPdf').click()})"
						></td>
					<td style="padding-left: 4px;"><base:button 
							title="Browse&hellip;"
							onclick="browseOnClick('caliperpdf', 'pdf', 'CALIPER_PDF')"
							id="btnCaliperPdf"
							/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="caliperpdf.status"></td>
				<td class="help"><span id="caliperpdf.message" class="message" style="display: none;"></span>
					Select the <b>PDF file</b> that contains a printout with diagrams and other
					useful documentation.
				</td>
			</tr>
			</tbody>
			<tr valign="top">
				<td class="prompt">Protocol</td>
				<td class="input" colspan="2"><select style="width:90%" name="libProtocol" id="libProtocol" 
					onkeypress="focusOnEnter(event, 'libComments')"></select></td>
				<td class="status" id="libProtocol.status"></td>
				<td class="help"><span id="libProtocol.message" class="message" style="display: none;"></span>
					Select the protocol used for library preparation.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input" colspan="2"><textarea rows="4" cols="50" style="width: 90%;" name="libComments" value="" onblur="libCommentsOnChange()"></textarea></td>
				<td class="status" id="libComments.status"></td>
				<td class="help"><span id="libComments.message" class="message" style="display: none;"></span>Comments about the library preparation.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>